#include "lsm6ds3.h"
//----------------------------------------------------
unsigned char read_buf[10]={0};
char str1[30]={0};
uint8_t buf2[14]={0};
//----------------------------------------------------
void Error(void)
{
	LD_ON;
}
//----------------------------------------------------
static void I2Cx_ReadData(unsigned char Addr, unsigned char Reg, unsigned char sz, unsigned char* value)
{
	unsigned char i=sz,n=0;
	I2C_StartCondition(); //   START
	I2C_SendByte(Addr); //      +  
	I2C_SendByte(Reg);//   
	I2C_StartCondition(); //   START
	I2C_SendByte(Addr|0x01); //      +  
	while(1)
	{
		if(i==1) break;
		value[n]=I2C_ReadByte();
		i--;n++;
	}
	value[sz-1]=I2C_ReadLastByte();
	I2C_StopCondition();//   STOP
}
//----------------------------------------------------
static void I2Cx_WriteData(unsigned char Addr, unsigned char Reg, unsigned char Value)
{
	I2C_StartCondition(); //   START
	I2C_SendByte(Addr); //      +  
	I2C_SendByte(Reg);//   
	I2C_SendByte(Value); //    
	I2C_StopCondition();//   STOP
}
//----------------------------------------------------
unsigned char Accel_ReadID(void)
{
	unsigned char ctrl=0;
	I2Cx_ReadData(0xD4,0x0F,1,read_buf);
	return ctrl;
}
//----------------------------------------------------
void AccelInit(void)
{
	//  
	I2Cx_ReadData(0xD4,LSM6DS3_ACC_GYRO_CTRL3_C,1,read_buf);
	read_buf[0]&=~LSM6DS3_ACC_GYRO_IF_INC_MASK;
	read_buf[0]|=LSM6DS3_ACC_GYRO_IF_INC_ENABLED;
	I2Cx_WriteData(0xD4,LSM6DS3_ACC_GYRO_CTRL3_C,read_buf[0]);
	//  BDU
	I2Cx_ReadData(0xD4,LSM6DS3_ACC_GYRO_CTRL3_C,1,read_buf);
	read_buf[0]&=~LSM6DS3_ACC_GYRO_BDU_MASK;
	read_buf[0]|=LSM6DS3_ACC_GYRO_BDU_BLOCK_UPDATE;
	I2Cx_WriteData(0xD4,LSM6DS3_ACC_GYRO_CTRL3_C,read_buf[0]);
	//  FIFO
	I2Cx_ReadData(0xD4,LSM6DS3_ACC_GYRO_FIFO_CTRL5,1,read_buf);
	read_buf[0]&=~LSM6DS3_ACC_GYRO_FIFO_MODE_MASK;
	read_buf[0]|=LSM6DS3_ACC_GYRO_FIFO_MODE_BYPASS;
	I2Cx_WriteData(0xD4,LSM6DS3_ACC_GYRO_FIFO_CTRL5,read_buf[0]);
	//   (ODR_XL = 0000)
	I2Cx_ReadData(0xD4,LSM6DS3_ACC_GYRO_CTRL1_XL,1,read_buf);
	read_buf[0]&=~LSM6DS3_ACC_GYRO_ODR_XL_MASK;
	read_buf[0]|=LSM6DS3_ACC_GYRO_ODR_XL_POWER_DOWN;
	I2Cx_WriteData(0xD4,LSM6DS3_ACC_GYRO_CTRL1_XL,read_buf[0]);
	//Full scale selection 2G
	I2Cx_ReadData(0xD4,LSM6DS3_ACC_GYRO_CTRL1_XL,1,read_buf);
	read_buf[0]&=~LSM6DS3_ACC_GYRO_FS_XL_MASK;
	read_buf[0]|=LSM6DS3_ACC_GYRO_FS_XL_2g;
	I2Cx_WriteData(0xD4,LSM6DS3_ACC_GYRO_CTRL1_XL,read_buf[0]);
	// 
	I2Cx_ReadData(0xD4,LSM6DS3_ACC_GYRO_CTRL9_XL,1,read_buf);
	read_buf[0]&=~(LSM6DS3_ACC_GYRO_XEN_XL_MASK|LSM6DS3_ACC_GYRO_YEN_XL_MASK|LSM6DS3_ACC_GYRO_ZEN_XL_MASK);
	read_buf[0]|=(LSM6DS3_ACC_GYRO_XEN_XL_ENABLED|LSM6DS3_ACC_GYRO_YEN_XL_ENABLED|LSM6DS3_ACC_GYRO_ZEN_XL_ENABLED);
	I2Cx_WriteData(0xD4,LSM6DS3_ACC_GYRO_CTRL9_XL,read_buf[0]);
	// Data Rate 104 
	I2Cx_ReadData(0xD4,LSM6DS3_ACC_GYRO_CTRL1_XL,1,read_buf);
	read_buf[0]&=~LSM6DS3_ACC_GYRO_ODR_XL_MASK;
	read_buf[0]|=LSM6DS3_ACC_GYRO_ODR_XL_104Hz;
	I2Cx_WriteData(0xD4,LSM6DS3_ACC_GYRO_CTRL1_XL,read_buf[0]);
}
//----------------------------------------------------
void Accel_GetXYZ(int16_t* pData)
{
	uint8_t buffer[6];
	uint8_t i=0;
	I2Cx_ReadData(0xD4,LSM6DS3_ACC_GYRO_OUTX_L_XL,6,buffer);
	for(i=0;i<3;i++)
	{
		pData[i]=((int16_t)((uint16_t)buffer[2*i+1]<<8)+buffer[2*i]);
	}
	
}
//----------------------------------------------------
void Accel_ReadAcc(void)
{
	int16_t buffer[3]={0};
	int16_t xval,yval,zval;
	Accel_GetXYZ(buffer);
	xval=buffer[0];
	yval=buffer[1];
	zval=buffer[2];
	//sprintf(str1,"X:%06d Y:%06d Z:%06d\r\n", xval, yval, zval);
	//USART_TX((uint8_t*)str1,strlen(str1));
	buf2[0]=0x11;
	buf2[1]=0x55;
	buf2[2]=(uint8_t)(xval>>8);
	buf2[3]=(uint8_t)xval;
	buf2[4]=(uint8_t)(yval>>8);
	buf2[5]=(uint8_t)yval;
	buf2[6]=(uint8_t)(zval>>8);
	buf2[7]=(uint8_t)zval;
	USART_TX(buf2,8);
	_delay_ms(50);
}
//----------------------------------------------------
void Accel_Ini(void)
{
	_delay_ms(500);
	Accel_ReadID();
	if(read_buf[0]!=0x69) Error();
	AccelInit();
}